package com.android.demo.notepad1
import _root_.android.app.{Activity, Dialog}
import _root_.android.view.View

case class TypedResource[T](id: Int)
case class TypedLayout(id: Int)

object TR {
  val text1 = TypedResource[android.widget.TextView](R.id.text1)
  val title = TypedResource[android.widget.EditText](R.id.title)
  val body = TypedResource[android.widget.EditText](R.id.body)
  val confirm = TypedResource[android.widget.Button](R.id.confirm)
 object layout {
  val notes_list = TypedLayout(R.layout.notes_list)
 val notes_row = TypedLayout(R.layout.notes_row)
 val note_edit = TypedLayout(R.layout.note_edit)
 }
}
trait TypedViewHolder {
  def findViewById( id: Int ): View
  def findView[T](tr: TypedResource[T]) = findViewById(tr.id).asInstanceOf[T]
}
trait TypedView extends View with TypedViewHolder
trait TypedActivityHolder extends TypedViewHolder
trait TypedActivity extends Activity with TypedActivityHolder
trait TypedDialog extends Dialog with TypedViewHolder
object TypedResource {
  implicit def layout2int(l: TypedLayout) = l.id
  implicit def view2typed(v: View) = new TypedViewHolder { 
    def findViewById( id: Int ) = v.findViewById( id )
  }
  implicit def activity2typed(a: Activity) = new TypedViewHolder { 
    def findViewById( id: Int ) = a.findViewById( id )
  }
  implicit def dialog2typed(d: Dialog) = new TypedViewHolder { 
    def findViewById( id: Int ) = d.findViewById( id )
  }
}
